# ===============================================================
# TestDictionary01.py: A dictionary is a collection which is
# unordered, changeable and indexed. No duplicate members.
# 
# Last Modified:                                       July, 2022
# ===============================================================

# main method ...

def main():
    print("--- Enter TestDictionary01.main()            ... ");
    print("--- ======================================== ... ");

    # Create and print simple dictionary ...

    print ("--- Create and print simple dictionary ...")

    car01 = {  "brand": "Honda",
               "model": "Acura",
               "miles": 25000,
                 "new": False,
                "year": 2016
            }

    print ("--- Car01: %s ..." %( car01 ))

    # Duplicates not Allowed ...

    print ("--- Create and print dictionary containing duplicates ...")

    car02 = {  "brand": "Honda",
               "model": "Acura",
               "miles": 50000,
               "miles": 60000,
                 "new": False,
                "year": 2016
            }

    print ("--- Car02: %s ..." %( car02 ))

    # Access items in dictionary ...

    print ("--- Access items in Car01 ...")

    print ("--- Car01: brand --> %s ..." %( car01.get("brand") ))
    print ("---      : model --> %s ..." %( car01.get("model") ))
    print ("---      : miles --> %d ..." %( car01.get("miles") ))
    print ("---      : new   --> %s ..." %( car01.get("new") ))
    print ("---      : year  --> %d ..." %( car01.get("year") ))

    # Retrieve keys from car01 ...

    print ("--- Retrieve keys from Car01 ...")
    print ("--- Car01 keys: %s ..." %( car01.keys() ))

    # Add new key to car01 ...

    print ("--- Add new key to Car01 ...")
    car01["color"] = "white"
    print ("--- Car01 keys: %s ..." %( car01.keys() ))
    print ("--- Car01: color --> %s ..." %( car01.get("color") ))

    # Update color of car01 ...

    print ("--- Paint car01 new color ...")

    car01["color"] = "blue"
    print ("--- Car01: color --> %s ..." %( car01.get("color") ))

    # Check to see if a key is in dictionary ...

    print ("--- Check to see if a key is in dictionary ...")
    
    if "model" in car01:
       print("---   Yes, 'model' is one of the keys in car01 dictionary")
    else:
       print("---   No, 'model' is not a key in car01 dictionary")
    
    if "selfdriving" in car01:
       print("---   Yes, 'selfdriving' is one of the keys in car01 dictionary")
    else:
       print("---   No, 'selfdriving' is not a key in car01 dictionary")

    # Update dictionary items...

    print ("--- Update dictionary items ...")

    car01.update({"color":  "red"})
    car01.update({"miles": 100000})

    print ("--- Car01: %s ..." %( car01 ))

    # Simple calulations with dictionaries ...

    print ("--- Simple calculations ...")

    prices = {
       "AAPL": 165.00,
       "AMZN": 144.00,
       "GOOG": 125.55,
       "META": 178.49,
       "NVDA": 188.41,
       "TWTR":  44.70,
       "TSLA": 919.00
    }

    print(prices)

    # Find min and max stock price ...

    print ("--- Compute min/max stock price ...")

    min_price = min(zip(prices.values(), prices.keys()))
    max_price = max(zip(prices.values(), prices.keys()))

    print ("--- Min price: ", min_price )
    print ("--- Max price: ", max_price )

    print ("--- Sorted prices ...")

    prices_sorted = sorted(zip(prices.values(), prices.keys()))
    for price, name in prices_sorted:
         print('    ', name, price)

    print("--- ======================================== ... ");
    print("--- Leave TestDictionnary01.main()           ... ");

# call the main method ...

main()
