# =========================================================
# TestEncoder02.py: One hot encoding with sklearn
# =========================================================

from numpy import array
from numpy import argmax
from sklearn.preprocessing import LabelEncoder
from sklearn.preprocessing import OneHotEncoder

print("=====================================================")
print("TestEncoder02.py ... ")
print("=====================================================")

# Input string of temperature levels ...

data = ['freeze', 'cold', 'warm', 'cold', 'hot', 'burn',
          'warm', 'burn', 'cold', 'warm', 'hot']
values = array(data)

print("--- Input values: %s" %(values))

# integer encode

print("--- Integer encode ...")

label_encoder   = LabelEncoder()
integer_encoded = label_encoder.fit_transform(values)

print(integer_encoded)

# binary encode

print("--- Binary encode ...")

onehot_encoder  = OneHotEncoder(sparse=False)
integer_encoded = integer_encoded.reshape(len(integer_encoded), 1)
onehot_encoded  = onehot_encoder.fit_transform(integer_encoded)

print(onehot_encoded)

# invert first example

print("--- Invert encoding ...")

inverted = label_encoder.inverse_transform([argmax(onehot_encoded[0, :])])
print(inverted)

print("--- Invert encoding ...")

print("--- Encoding[ 0] : %s" %( label_encoder.inverse_transform([argmax(onehot_encoded[0, :])])))
print("--- Encoding[ 1] : %s" %( label_encoder.inverse_transform([argmax(onehot_encoded[1, :])])))
print("--- Encoding[ 2] : %s" %( label_encoder.inverse_transform([argmax(onehot_encoded[2, :])])))
print("--- Encoding[ 3] : %s" %( label_encoder.inverse_transform([argmax(onehot_encoded[3, :])])))

print("=====================================================")
print("Finished !! ")
