# ============================================================
# Circle.py: Implementation of circle model with protection of
# circle parameters and methods.
# 
# Written by: Mark Austin                        October, 2020 
# ============================================================

import math

class Circle:
  _radius = 0
  _area   = 0
  _perimeter = 0

  def __init__(self, x, y, radius):
    self._radius    = radius
    self._area      = math.pi*radius*radius
    self._perimeter = 2.0*math.pi*radius
    self._x = x
    self._y = y

  # Set circle coordinates ...

  def setX(self, x):
    self._x = x

  def setY(self, y):
    self._y = y

  # Set circle radius, recompute area and perimeter ...

  def setRadius(self, radius):
    self._radius = radius
    self._area   = math.pi*radius*radius
    self._perimeter = 2.0*math.pi*radius

  # Get circle parameters ...

  def getX(self):
    return self._x

  def getY(self):
    return self._y

  def getRadius(self):
    return self._radius

  def getArea(self):
    return self._area

  def getPerimeter(self):
    return self._perimeter

  # String represention of circle ...

  def __str__(self):
     return "--- Circle: (x,y) = (%.2f, %.2f): radius = %.2f: area = %.2f: perimeter = %.2f" % (
            self._x, self._y, self._radius, self._area, self._perimeter )


