# ============================================================
# Student.py: A Student is a specialization of Person ...
# ============================================================

from Person import Person

class Student(Person):
   _gpa = 0

   # -------------------------------------------
   # Parameterized constructor ...
   # -------------------------------------------

   def __init__(self, fname, lname, dob, year):
     Person.__init__(self, fname, lname, dob)
     self._graduationyear = year

   # -------------------------------------------
   # Set/get gpa ...
   # -------------------------------------------

   def setGpa(self, gpa):
     self._gpa = gpa

   def getGpa(self):
     return self._gpa

   # -------------------------------------------
   # Boolean to confirm person is a student ...
   # -------------------------------------------

   def isStudent(self):  
      return True

   # -------------------------------------------
   # Assemble string represention of student ...
   # -------------------------------------------

   def __str__(self):
      studentinfo = [];
      studentinfo.append("\n");
      studentinfo.append("--- Student: {:s} {:s} ...  \n".format( self._firstname, self._lastname));
      studentinfo.append("--- ------------------------------------------------- \n");
      studentinfo.append("---   Gpa = {:6.2f} ... \n".format( self._gpa));
      studentinfo.append("---   Age = {:6d} ... \n".format( self._age));
      studentinfo.append("---   Graduation year = {:d} ... \n".format( self._graduationyear ));
      studentinfo.append("--- ------------------------------------------------- ");
      return "".join(studentinfo);
