# ====================================================================
# TestStudents02.py: Assemble list of students ...
# 
# Written by: Mark Austin                                February 2023
# ====================================================================

from Student import Student
from datetime import date

# main method ...

def main():
    print("--- Enter TestStudents02.main()                         ... ");
    print("--- =================================================== ... ");

    print("--- ")
    print("--- Part 1: Create student objects ...")

    student01 = Student( "Angela", "Austin", date(2002, 3, 2), 2023)
    student01.setGpa(3.5), student01.setSSN(1234)

    student02 = Student( "Nina", "Austin", date(2001, 4, 12), 2025)
    student02.setGpa(3.2), student02.setSSN(2134)

    student03 = Student( "David", "Austin", date(2000, 6, 8), 2025)
    student03.setGpa(2.9), student03.setSSN(2143)

    student04 = Student( "Marie", "Austin", date(2005, 8, 5), 2026)
    student04.setGpa(3.9), student04.setSSN(1243)

    student05 = Student( "Albert", "Austin", date(1999, 10, 20), 2026)
    student05.setGpa(3.8), student05.setSSN(3124)

    student06 = Student( "Aaron", "Austin", date(2002, 12, 2), 2026)
    student06.setGpa(4.0), student06.setSSN(1131)

    print("--- ")
    print("--- Part 2: String description of student parameters ...")

    print( student01.__str__() )
    print( student02.__str__() )
    print( student03.__str__() )
    print( student04.__str__() )
    print( student05.__str__() )
    print( student06.__str__() )

    print("--- ")
    print("--- Part 3: Add students to list ... ")

    studentList = [];
    studentList.append(student01)
    studentList.append(student02)
    studentList.append(student03)
    studentList.append(student04)
    studentList.append(student05)
    studentList.append(student06)

    print("--- ")
    print("--- Part 4: Print contents of list ... ")

    i = 0
    for student in studentList:
       print ("---   list01[{:d}]: {:6s} --> {:.2f} ...".format( i, student.getFirstName(), student.getGpa() ))
       i = i + 1

    print("--- ")
    print("--- Part 5: Sort list items by first name ... ")

    sort_values = sorted( studentList, key = lambda x: x._firstname )

    i = 0
    for student in sort_values:
       print ("---   list01[{:d}]: {:6s} --> {:.2f} ...".format( i, student.getFirstName(), student.getGpa() ))
       i = i + 1

    print("--- ")
    print("--- Part 6: Sort list items by gpa ... ")

    sort_values = sorted( studentList, key = lambda x: x._gpa )

    i = 0
    for student in sort_values:
       print ("---   list01[{:d}]: {:6s} --> {:.2f} ...".format( i, student.getFirstName(), student.getGpa() ))
       i = i + 1

    print("--- =================================================== ... ");
    print("--- Finished TestStudents02.main()                      ... ");

# call the main method ...

main()
