# ===============================================================
# TestReadAirPassengers.py: Read and plot AirPassengers.csv.
# 
#                                                  November, 2022 
# ===============================================================

from pandas import DataFrame
from pandas import Series
from pandas import read_csv

import numpy as np 
import pandas as pd

import matplotlib.pyplot as plt

# main method ...

def main():
    print("--- Enter TestReadAirPassengers.main()                       ... ");
    print("--- ======================================================== ... ");

    # Load CSV file into a Pandas dataframe ...

    print("--- ");
    print("--- Part 01: load CSV file into Pandas dataframe ... ");
    print("--- ");
 
    df = pd.read_csv('../data/AirPassengers.csv')
    print(df.head()) 

    print("--- ");
    print("--- dataframe info and shape ... ");
    print("--- ");

    print(df.info() )
    print(df.shape)

    print("--- ");
    print("--- Part 02: Create plot of AirPassengers vs time ... ");
    print("--- ");

    ax = plt.gca()
    df.plot(kind='line',x='Month',y='#Passengers',color='blue',ax=ax)
    plt.show()

    print("--- ======================================================== ... ");
    print("--- Leave TestReadAirPassengers.main()                       ... ");

# call the main method ...

main()
