# ========================================================================
# TestReadSensorDataCSV.py. Read small sensor data file ...
# 
# Written by: Mark Austin                                    November 2022
# ========================================================================

from pandas import DataFrame
from pandas import Series
from pandas import read_csv

import numpy as np 
import pandas as pd

import matplotlib.pyplot as plt

# ==============================
# main method ...
# ==============================

def main():
    print("--- Enter TestReadSensorDataCSV.main()       ... ");
    print("--- ======================================== ... ");

    # load dataset

    print("--- ");
    print("--- Part 01: Load small sensor data file ... ");
    print("--- ");

    df = pd.read_csv("../data/pandas/sensors.csv")

    # print dataframe contents ...

    print("--- ");
    print("--- Part 02: Print dataframe contents ... ");
    print("--- ");

    print(df)

    # Filter dataframe to keep only the "accel" entries ...
    # selecting rows based on condition 
    # Assign index numbers to 0, 1, ... 122.

    print("--- ");
    print("--- Part 03: Filter dataframe to keep only acceleration entries ... ")
    print("--- ");

    options = ['accel'] 
    df_accel = df [ df['sensor'].isin(options) ].copy()  
    
    print('--- Accel dataframe :\n', df_accel )
    print("--- ");

    # Filter dataframe to keep only the MSFT entries ...
    # selecting rows based on condition 

    print("--- ");
    print("--- Part 04: Filter dataframe to keep orientation entries ... ")
    print("--- ");

    options = ['orientation'] 
    df_orientation = df [ df['sensor'].isin(options) ].copy() 

    print('--- Orientation dataframe :\n', df_orientation )

    print("--- ======================================== ... ");
    print("--- Leave TestReadSensorDataCSV.main()       ... ");

# ==================================================
# call the main method ...
# ==================================================

main()
