# ===============================================================
# TestPandasSeries01.py: Exercise Pandas Series ...
# ===============================================================

import numpy as np
import pandas as pd

# main method ...

def main():
    print("--- Enter TestPandasSeries01.main()                          ... ");
    print("--- ======================================================== ... ");

    # Manually create a series from a list ...

    print("--- ");
    print("--- Part 01: Create series from a list ... ");
    print("--- ");

    a = [1, 2, 3, 4, 3, 2, 1 ]
    myvar = pd.Series(a)
    print(myvar)

    print("--- ");
    print("--- Part 02: Create series from a list with labels ... ");
    print("--- ");

    myvar = pd.Series(a, index = ["a", "b", "c", "d", "c", "b", "a" ])
    print(myvar)

    # Create series from a dictionary ...

    print("--- ");
    print("--- Part 03: Create series from a dictionary ... ");
    print("--- ");

    calories = {"day1": 420, "day2": 380, "day3": 390}
    myvar = pd.Series(calories)

    print(myvar)

    # Create series from a dictionary ...

    print("--- ");
    print("--- Part 04: Create series using NumPy functions ... ");
    print("--- ");

    print("--- series01 = pd.Series(np.arange(2,8)) ... ");

    series01 = pd.Series(np.arange(2,8))
    print(series01)

    print("--- series02 = pd.Series( np.linspace(0,10,5)) ... ");

    series02 = pd.Series( np.linspace(0,10,5))
    print(series02)

    print("--- series02.size ... ");
    print(series02.size)

    print("--- series02 length ... ");
    print( len(series02) )

    print("--- series02 values ... ");
    print( series02.values )

    # Create simple dataframe from multiple series ...

    print("--- ");
    print("--- Part 05: Create simple dataframe from mutiple series ... ");
    print("--- ");

    data = {
       "calories": [420, 380, 390],
       "duration": [50, 40, 45]
    }

    myvar = pd.DataFrame(data)
    print(myvar)

    print("--- ");
    print("--- Part 06: Give each row a name ... ");
    print("--- ");

    myvar = pd.DataFrame(data, index = ["day1", "day2", "day3"])
    print(myvar) 

    print("--- ======================================================== ... ");
    print("--- Leave TestPandasSeries01.main()                                ... ");

# call the main method ...

main()
